"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SupportCodeExecutor_1 = require("./SupportCodeExecutor");
class PredictableHook {
    constructor(id, scenarioId, location, status, duration, errorMessage) {
        this.id = id;
        this.scenarioId = scenarioId;
        this.location = location;
        this.status = status;
        this.duration = duration;
        this.errorMessage = errorMessage;
    }
    match(pickle) {
        if (!pickle.astNodeIds.includes(this.scenarioId)) {
            return null;
        }
        return new SupportCodeExecutor_1.NilCodeExecutor(null);
    }
    toMessage() {
        const locationChunks = this.location.split(':');
        return {
            hook: {
                id: this.id,
                sourceReference: {
                    uri: locationChunks[0],
                    location: {
                        line: parseInt(locationChunks[1]),
                    },
                },
            },
        };
    }
}
exports.default = PredictableHook;
//# sourceMappingURL=PredictableHook.js.map