"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const messages = __importStar(require("@cucumber/messages"));
const SupportCodeExecutor_1 = require("./SupportCodeExecutor");
class PredictableStepDefinition {
    constructor(id, stepId, location, status, duration, errorMessage) {
        this.id = id;
        this.stepId = stepId;
        this.location = location;
        this.status = status;
        this.duration = duration;
        this.errorMessage = errorMessage;
    }
    match(pickleStep) {
        if (pickleStep.astNodeIds.includes(this.stepId)) {
            return new SupportCodeExecutor_1.NilCodeExecutor(this.id);
        }
        return null;
    }
    toMessage() {
        const locationChunks = this.location.split(':');
        return {
            stepDefinition: {
                id: this.id,
                sourceReference: {
                    uri: locationChunks[0],
                    location: {
                        line: parseInt(locationChunks[1]),
                    },
                },
                pattern: {
                    source: '[unknown regexp source]',
                    type: messages.StepDefinitionPatternType.REGULAR_EXPRESSION,
                },
            },
        };
    }
}
exports.default = PredictableStepDefinition;
//# sourceMappingURL=PredictableStepDefinition.js.map