"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const PredictableHook_1 = __importDefault(require("./PredictableHook"));
const PredictableStepDefinition_1 = __importDefault(require("./PredictableStepDefinition"));
class PredictableSupportCode {
    constructor(supportCode) {
        this.supportCode = supportCode;
    }
    addPredictableBeforeHook(location, scenarioId, status, duration, stack) {
        const id = this.supportCode.newId();
        this.supportCode.registerBeforeHook(new PredictableHook_1.default(id, scenarioId, location, this.statusFromString(status), duration || 0, stack));
    }
    addPredictableAfterHook(location, scenarioId, status, duration, stack) {
        const id = this.supportCode.newId();
        this.supportCode.registerAfterHook(new PredictableHook_1.default(id, scenarioId, location, this.statusFromString(status), duration || 0, stack));
    }
    addPredictableStepDefinition(location, stepId, status, duration, stack) {
        const id = this.supportCode.newId();
        this.supportCode.registerStepDefinition(new PredictableStepDefinition_1.default(id, stepId, location, this.statusFromString(status), duration || 0, stack));
    }
    statusFromString(status) {
        // @ts-ignore
        return status.toUpperCase();
    }
}
exports.default = PredictableSupportCode;
//# sourceMappingURL=PredictableSupportCode.js.map