import * as messages from '@cucumber/messages';
import { EnvelopeListener, ITestStep, IWorld, TestStep } from '@cucumber/fake-cucumber';
declare abstract class PredictableTestStep extends TestStep implements ITestStep {
    readonly id: string;
    readonly sourceId: string;
    readonly alwaysExecute: boolean;
    private readonly status;
    private readonly duration;
    private readonly errorMessage?;
    constructor(id: string, sourceId: string, alwaysExecute: boolean, status: messages.TestStepResultStatus, duration: number, errorMessage?: string);
    execute(_: IWorld, testCaseStartedId: string, listener: EnvelopeListener): Promise<messages.TestStepResult>;
}
export declare class PredictablePickleTestStep extends PredictableTestStep {
    readonly id: string;
    readonly sourceId: string;
    readonly alwaysExecute: boolean;
    private readonly stepDefinitionId;
    constructor(id: string, sourceId: string, alwaysExecute: boolean, stepDefinitionId: string, status: messages.TestStepResultStatus, duration: number, errorMessage?: string);
    toMessage(): messages.TestStep;
}
export declare class PredictableHookTestStep extends PredictableTestStep {
    toMessage(): messages.TestStep;
}
export {};
//# sourceMappingURL=PredictableTestSteps.d.ts.map