"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PredictableHookTestStep = exports.PredictablePickleTestStep = void 0;
const messages = __importStar(require("@cucumber/messages"));
const fake_cucumber_1 = require("@cucumber/fake-cucumber");
class PredictableTestStep extends fake_cucumber_1.TestStep {
    constructor(id, sourceId, alwaysExecute, status, duration, errorMessage) {
        // TODO: Rather than injecting a PerfHooksStopwatch here we should inject one that uses duration.
        // That will also require a different API for measuring duration...
        super(id, sourceId, alwaysExecute, [], [], new fake_cucumber_1.DateClock(), new fake_cucumber_1.PerfHooksStopwatch(), null);
        this.id = id;
        this.sourceId = sourceId;
        this.alwaysExecute = alwaysExecute;
        this.status = status;
        this.duration = duration;
        this.errorMessage = errorMessage;
    }
    execute(_, testCaseStartedId, listener) {
        return __awaiter(this, void 0, void 0, function* () {
            this.emitTestStepStarted(testCaseStartedId, listener);
            return this.emitTestStepFinished(testCaseStartedId, {
                duration: messages.TimeConversion.millisecondsToDuration(this.duration),
                status: this.status,
                message: this.errorMessage,
            }, listener);
        });
    }
}
class PredictablePickleTestStep extends PredictableTestStep {
    constructor(id, sourceId, alwaysExecute, stepDefinitionId, status, duration, errorMessage) {
        super(id, sourceId, alwaysExecute, status, duration, errorMessage);
        this.id = id;
        this.sourceId = sourceId;
        this.alwaysExecute = alwaysExecute;
        this.stepDefinitionId = stepDefinitionId;
    }
    toMessage() {
        const stepDefinitionIds = this.stepDefinitionId ? [this.stepDefinitionId] : [];
        return {
            id: this.id,
            pickleStepId: this.sourceId,
            stepDefinitionIds: stepDefinitionIds,
        };
    }
}
exports.PredictablePickleTestStep = PredictablePickleTestStep;
class PredictableHookTestStep extends PredictableTestStep {
    toMessage() {
        return {
            id: this.id,
            hookId: this.sourceId,
        };
    }
}
exports.PredictableHookTestStep = PredictableHookTestStep;
//# sourceMappingURL=PredictableTestSteps.js.map