"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const gherkinDocumentToSource_1 = __importDefault(require("./gherkinDocumentToSource"));
describe('gherkinDocumentToSource', () => {
    it('provides the correct source uri', () => {
        const source = gherkinDocumentToSource_1.default({
            uri: 'path/to/file.feature',
            comments: [],
        });
        assert_1.default.strictEqual(source.uri, 'path/to/file.feature');
    });
    it('provides the correct media type', () => {
        const source = gherkinDocumentToSource_1.default({
            uri: 'path/to/file.feature',
            comments: [],
        });
        assert_1.default.strictEqual(source.mediaType, 'text/x.cucumber.gherkin+plain');
    });
    xit('it produces the Gherkin original document', () => {
        // This may be implemented later on.
        const source = gherkinDocumentToSource_1.default({
            feature: {
                name: 'My feature',
                location: { line: 1 },
                keyword: 'Feature',
                language: 'en',
                children: [],
                tags: [],
                description: '',
            },
            comments: [],
        });
        assert_1.default.strictEqual(source.data, 'Feature: My feature\n');
    });
});
//# sourceMappingURL=gherkinDocumentToSourceTest.js.map