"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const makePredictableHookTestStep_1 = __importDefault(require("../../src/test-generation/makePredictableHookTestStep"));
const messages = __importStar(require("@cucumber/messages"));
const PredictableHook_1 = __importDefault(require("../../src/PredictableHook"));
describe('makePredictableHookTestStep', () => {
    const passedHook = new PredictableHook_1.default('some-id', 'scenario-id', 'somewhere.rb:11', messages.TestStepResultStatus.PASSED, 123456);
    it('returns undefined when the Hook does not match', () => {
        const pickle = {
            astNodeIds: ['another-scenario-id'],
            steps: [],
            id: 'id',
            language: 'en',
            tags: [],
            uri: 'uri',
            name: 'Name',
        };
        const step = makePredictableHookTestStep_1.default(pickle, passedHook, true, null, messages.IdGenerator.uuid());
        assert_1.default.strictEqual(step, undefined);
    });
    it('creates a PredictableHookTestStep', () => __awaiter(void 0, void 0, void 0, function* () {
        const pickle = {
            astNodeIds: ['scenario-id'],
            steps: [],
            id: 'id',
            language: 'en',
            tags: [],
            uri: 'uri',
            name: 'Name',
        };
        const step = makePredictableHookTestStep_1.default(pickle, passedHook, true, null, messages.IdGenerator.uuid());
        const testResult = yield step.execute(null, '', () => null, true);
        assert_1.default.strictEqual(testResult.status, messages.TestStepResultStatus.PASSED);
        assert_1.default.strictEqual(testResult.duration.seconds, 123);
    }));
});
//# sourceMappingURL=makePredictableHookTestStepTest.js.map