"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const makePredictablePickleTestStep_1 = __importDefault(require("../../src/test-generation/makePredictablePickleTestStep"));
const messages = __importStar(require("@cucumber/messages"));
const PredictableStepDefinition_1 = __importDefault(require("../../src/PredictableStepDefinition"));
describe('makePredictablePickleTestStep', () => {
    it('returns a TestStep with status Undefined when there is no matching step', () => __awaiter(void 0, void 0, void 0, function* () {
        const step = makePredictablePickleTestStep_1.default('test-step-id', {
            astNodeIds: [],
            id: '1',
            text: 'hello',
        }, []);
        const result = yield step.execute(null, 'some-id', () => null, true);
        assert_1.default.strictEqual(result.status, 'UNDEFINED');
        assert_1.default.strictEqual(result.duration.seconds, 0);
        assert_1.default.strictEqual(result.duration.nanos, 0);
    }));
    it('returns a TestStep which will take the status of the first matching StepDefinition', () => __awaiter(void 0, void 0, void 0, function* () {
        const step = makePredictablePickleTestStep_1.default('test-step-id', {
            astNodeIds: ['some-step-id'],
            id: '1',
            text: 'hello',
        }, [
            new PredictableStepDefinition_1.default('some-id', 'some-step-id', 'somewhere', messages.TestStepResultStatus.SKIPPED, 987654),
        ]);
        const result = yield step.execute(null, 'some-id', () => null, true);
        assert_1.default.strictEqual(result.status, messages.TestStepResultStatus.SKIPPED);
        assert_1.default.strictEqual(result.duration.seconds, 987);
        assert_1.default.strictEqual(result.duration.nanos, 654000000);
    }));
    it('correctly sets the error message if existing', () => __awaiter(void 0, void 0, void 0, function* () {
        const step = makePredictablePickleTestStep_1.default('test-step-id', {
            astNodeIds: ['some-step-id'],
            id: '1',
            text: 'hello',
        }, [
            new PredictableStepDefinition_1.default('some-id', 'some-step-id', 'somewhere', messages.TestStepResultStatus.FAILED, 987654, 'An error has been raised here'),
        ]);
        const result = yield step.execute(null, 'some-id', () => null, true);
        assert_1.default.strictEqual(result.message, 'An error has been raised here');
    }));
});
//# sourceMappingURL=makePredictablePickleTestStepTest.js.map